#pragma once
#include "resource.h"       // main symbols
#include "EProCallExt.h"

class ATL_NO_VTABLE CContactHandler :
	  public CComObjectRootEx < CComSingleThreadModel >
	, public CComCoClass < CContactHandler, &CLSID_ContactHandler >
	, public ECtiClientLib::IClientAddIn
	, public IDispatchImpl < ECtiClientLib::IContactHandler, &__uuidof(ECtiClientLib::IContactHandler), &__uuidof(ECtiClientLib::__ECtiClientLib) >
{
public:
	// Helpers
	static HRESULT GetContact(const long nIndex, IDispatch* pContactOSP, ECtiClientLib::IECOMContact** ppContact);

	DECLARE_REGISTRY_RESOURCEID(IDR_CONTACTHANDLER)

	BEGIN_COM_MAP(CContactHandler)
		COM_INTERFACE_ENTRY(ECtiClientLib::IClientAddIn)
		COM_INTERFACE_ENTRY(ECtiClientLib::IContactHandler)
		COM_INTERFACE_ENTRY2(IDispatch, ECtiClientLib::IContactHandler)
	END_COM_MAP()

	DECLARE_PROTECT_FINAL_CONSTRUCT()

	// IClientAddIn interface
	STDMETHOD(raw_GetAbout) (/*out*/ BSTR* pbstrAbout, /*out*/ BSTR* pbstrInfo);
	STDMETHOD(raw_OnLoad) (/*in*/ IDispatch* pClientApplication) { return E_NOTIMPL; }
	STDMETHOD(raw_OnUnload) () { return E_NOTIMPL; }

	// IContactHandler Implementation
	STDMETHOD(raw_OnRegisterHandler) (
		/*[out, retval]*/ VARIANT* pvarAddInName);
	STDMETHOD(raw_QueryOptions) (
		/*[out,retval]*/ long* plOptions) { return E_NOTIMPL; };
	STDMETHOD(raw_IsContactFieldAvailable) (
		/*[in]*/ long lPropertyTag,
		/*[out,retval]*/ long* pbRetC) { return E_NOTIMPL; };
	STDMETHOD(raw_OnContactNewExecute) (
		/*[in]*/ BSTR       bstrFolderID,
		/*[in]*/ IDispatch* pContactOSP);
	STDMETHOD(raw_OnChooseFolder) (
		/*[in]*/ long lParent,
		/*[out,retval]*/ VARIANT* pvarFolderID) { return E_NOTIMPL; };
	STDMETHOD(raw_GetDefaultLocationFromType) (
		/*[in]*/ long lFolderType,
		/*[out]*/ BSTR * pbstrFolderStoreID,
		/*[out]*/ BSTR * pbstrFolderEntryID) { return E_NOTIMPL; };
	STDMETHOD(raw_GetDisplayNamesFromIDs) (
		/*[in]*/ BSTR bstrFolderStoreID,
		/*[in]*/ BSTR bstrFolderEntryID,
		/*[out]*/ BSTR * pbstrStoreName,
		/*[out]*/ BSTR * pbstrFolderName) { return E_NOTIMPL; };
	STDMETHOD (raw_OnContactOpen) (
		/*[in]*/ IDispatch* pContactOSP);
	STDMETHOD (raw_OnGetContactByID) (
		/*[in]*/ IDispatch* pContactOSP);

	// Attributes
	IDispatchPtr m_spContactOSP; // extend livetime
};

OBJECT_ENTRY_AUTO(__uuidof(ContactHandler), CContactHandler)
