#pragma once

template < class T, const GUID* plibid = &CAtlModule::m_libid, WORD wMajor = 1, WORD wMinor = 0 >
class ATL_NO_VTABLE IContactHandlerImpl :
	public IDispatchImpl < IContactHandler, &__uuidof(IContactHandler), plibid, wMajor, wMinor >
{
public:
	BEGIN_COM_MAP(IContactHandlerImpl < T > )
		COM_INTERFACE_ENTRY(IContactHandler)
		COM_INTERFACE_ENTRY2(IDispatch, IContactHandler)
	END_COM_MAP()

// Helpers
	static HRESULT GetContact(const long nIndex, IDispatch* pContactOSP, IECOMContact** ppContact)
	{
		HRESULT hr = E_NOINTERFACE;
		CComQIPtr < IECOMContacts > spContacts(pContactOSP);
		if(spContacts)
		{
			IUnknownPtr spUnk;
			hr = spContacts->get_Item(nIndex, &spUnk);
			if(spUnk)
				hr = spUnk->QueryInterface(__uuidof(*ppContact), (void**) ppContact);
		}

		return hr;
	}

// IContactHandler implementation
public:
	STDMETHOD (OnRegisterHandler) (
		/*[out, retval]*/ VARIANT* pvarAddInName)
	{
		HRESULT hr = NOERROR;

		CComVariant varName(L"SDKSampleAddIn");
		hr = varName.Detach(pvarAddInName);
		return hr;
	};

	STDMETHOD (QueryOptions) (
		/*[out, retval]*/ long* plOptions)
	{
		return E_NOTIMPL;
	}

	STDMETHOD (IsContactFieldAvailable) (
		/*[in]*/  long lPropertyTag,
		/*[out, retval]*/ BOOL* pbRetC)
	{
		if(NULL == pbRetC)
			return E_POINTER;

		*pbRetC = TRUE;
		return NOERROR;
	}

	STDMETHOD (OnContactNewExecute) (
		/*[in]*/ BSTR       bstrFolderID,
		/*[in]*/ IDispatch* pContactOSP)
	{
		CComQIPtr < IECOMContacts > spContacts(pContactOSP);
		if(NULL == spContacts)
			return E_FAIL;

		IUnknownPtr spUnk;
		spContacts->get_Item(1, &spUnk);
		CComQIPtr < IECOMContact > spContact(spUnk);
		if(NULL == spContact)
			return E_FAIL;

		::MessageBox(NULL, _T("FromInsideAddIn::OnContactNewExecute()"), _T("SDKSample ContactHandler"), MB_OK | MB_ICONINFORMATION);

		// return the current values
		spContact->put_DisplayName(CComBSTR(L"created by your handler"));

		// IMPORTANT: return the unique identifier of your contact currently created
		spContact->put_EntryID(CComBSTR(L"unique"));
		return NOERROR;
	}

	STDMETHOD (OnChooseFolder) (
		/*[in]*/ long              lParent,
		/*[out, retval]*/ VARIANT* pvarFolderID)
	{
		return E_NOTIMPL;
	}

	STDMETHOD (GetDefaultLocationFromType) (
		/*[in]*/ long   lFolderType,
		/*[out]*/ BSTR* pbstrFolderStoreID,
		/*[out]*/ BSTR* pbstrFolderEntryID)
	{
		return E_NOTIMPL;
	}

	STDMETHOD (GetDisplayNamesFromIDs) (
		/*[in]*/ BSTR   bstrFolderStoreID,
		/*[in]*/ BSTR   bstrFolderEntryID,
		/*[out]*/ BSTR* pbstrStoreName,
		/*[out]*/ BSTR* pbstrFolderName)
	{
		return E_NOTIMPL;
	}

	STDMETHOD (OnContactOpen) (
		/*[in]*/ IDispatch* pContactOSP)
	{
		CComQIPtr < IECOMContacts > spContacts(pContactOSP);
		CComBSTR bstrDisplayName;
		if (spContacts)
		{
			IUnknownPtr spUnk;
			spContacts->get_Item(1, &spUnk);
			CComQIPtr < IECOMContact > spContact(spUnk);
			spContact->get_DisplayName(&bstrDisplayName);
		}

		TCHAR szMsg[0x100];
		_sntprintf_s(szMsg, 0xff, _T("FromInsideAddIn::OnContactOpen() on %ls"), (BSTR) bstrDisplayName);
		szMsg[0xff] = _T('\0');
		::MessageBox(NULL, szMsg, _T("SDKSample ContactHandler"), MB_OK | MB_ICONINFORMATION);

		return NOERROR;
	}

	STDMETHOD (OnGetContactByID) (
		/*[in]*/ IDispatch* pContactOSP)
	{
		return E_NOTIMPL;
	}
};
