#include "StdAfx.h"
#include "COMTools.h"

BSTR FormatMessageFromModule (const _com_error& e, LPCTSTR szModule)
{
	_bstr_t bstrMsg;

	if(e.ErrorMessage()) // add information from system message-table resource(s)
	{
		bstrMsg += e.ErrorMessage();
		bstrMsg += L"\r\n";
	}

	if(0 < e.Description().length())
	{
		bstrMsg += e.Description().GetBSTR(); // add "Custom" Description provided by IErrorInfo
		bstrMsg += L"\r\n";
	}

	const HRESULT hr = e.Error();
	if (FACILITY_ITF == HRESULT_FACILITY(hr))
	{
		TCHAR* pszMsg = NULL;
		::FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER|FORMAT_MESSAGE_FROM_HMODULE,
			::GetModuleHandle(szModule),
			hr,
			MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
			(LPTSTR)&pszMsg,
			0,
			NULL);
		if (NULL != pszMsg)
		{
			bstrMsg += pszMsg;
			bstrMsg += L"\r\n";
			::LocalFree(pszMsg);
		}
	}

	bstrMsg += e.Source();
	return bstrMsg.Detach();
}
