// ECrmAddIn.cpp : Implementation of DLL Exports.


#include "stdafx.h"
#include "resource.h"
#include "ECrmAddIn.h"
#include "Configuration.h"

class CECrmAddInModule : public CAtlDllModuleT< CECrmAddInModule >
{
public :
	DECLARE_LIBID(LIBID_ECrmAddInLib)
	DECLARE_REGISTRY_APPID_RESOURCEID(IDR_ECRMADDIN, "{A40600F6-C905-4818-8E5E-897B770AD432}")

	CECrmAddInModule ()
	{
		// set the baseURL to YOUR server (and optional the port) here. e.g. http://localhost:80/
		m_bstrServerPort = L"http://localhost/";
	}

	HRESULT GetConfigFromSummary (HINSTANCE hInstance, DWORD dwReason)
	{
		USES_CONVERSION;
		HRESULT hr = NOERROR;
		if (DLL_PROCESS_ATTACH == dwReason)
		{
			TCHAR szModuleFileName[MAX_PATH] = {_T('\0')};
			DWORD dwRetC = ::GetModuleFileName(hInstance, szModuleFileName, _countof(szModuleFileName));
			CComPtr < IPropertySetStorage > spPSS;
			const DWORD grfMode = STGM_READWRITE | STGM_SHARE_EXCLUSIVE; // STGM_SHARE_DENY_NONE;
			hr = ::StgOpenStorageEx(szModuleFileName, grfMode, STGFMT_FILE, 0, NULL, NULL, __uuidof(spPSS), (void**) &spPSS);
			if (FAILED(hr))
				return hr;

			CComPtr < IPropertyStorage > spPS;
			hr = spPSS->Open(FMTID_SummaryInformation, grfMode, &spPS); // FMTID_SummaryInformation, FMTID_UserDefinedProperties
			if (FAILED(hr))
				return hr;

			PROPSPEC rgpspec[1] = { PRSPEC_PROPID, PIDSI_SUBJECT };
			PROPVARIANT propvar;
			::PropVariantInit(&propvar);
			hr = spPS->ReadMultiple(1, rgpspec, &propvar);
			if (FAILED(hr))
				return hr;

			switch (propvar.vt)
			{
			case VT_LPSTR:
				m_bstrServerPort = A2W(propvar.pszVal);
				break;

			case VT_BSTR:
				m_bstrServerPort = propvar.bstrVal;
				break;

			case VT_LPWSTR:
				m_bstrServerPort = propvar.pwszVal;
				break;
			}

			::PropVariantClear(&propvar);
		}

		return hr;
	}

	CComBSTR m_bstrServerPort;
};

CECrmAddInModule _AtlModule;

#ifdef _MANAGED
#pragma managed(push, off)
#endif

// DLL Entry Point
extern "C" BOOL WINAPI DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID lpReserved)
{
	USES_CONVERSION;
	BOOL bRetC = _AtlModule.DllMain(dwReason, lpReserved);

	HRESULT hr = _AtlModule.GetConfigFromSummary(hInstance, dwReason);
	if (FAILED(hr) && (DLL_PROCESS_ATTACH == dwReason))
	{
		CRegKey rk;
		TCHAR szBaseURL[0x100] = { _T('\0') };
		ULONG ulChars = _countof(szBaseURL);
		LONG lRetC = ERROR_SUCCESS;
		if (ERROR_SUCCESS == rk.Open(HKEY_LOCAL_MACHINE, _T("Software\\Policies\\") REG_PATH_CONFIGURATION, KEY_READ))
		{
			lRetC = rk.QueryStringValue(REG_VALUENAME_CONFIGURATION, szBaseURL, &ulChars);
			if (ERROR_SUCCESS == lRetC)
			{
				_AtlModule.m_bstrServerPort = szBaseURL;
				return bRetC;
			}

			rk.Close();
		}

		if (ERROR_SUCCESS == rk.Open(HKEY_CURRENT_USER, _T("Software\\Policies\\") REG_PATH_CONFIGURATION, KEY_READ))
		{
			ulChars = _countof(szBaseURL);
			if (ERROR_SUCCESS == rk.QueryStringValue(REG_VALUENAME_CONFIGURATION, szBaseURL, &ulChars))
			{
				_AtlModule.m_bstrServerPort = szBaseURL;
				return bRetC;
			}

			rk.Close();
		}

		if (ERROR_SUCCESS == rk.Open(HKEY_CURRENT_USER, _T("Software\\") REG_PATH_CONFIGURATION, KEY_READ))
		{
			ulChars = _countof(szBaseURL);
			if (ERROR_SUCCESS == rk.QueryStringValue(REG_VALUENAME_CONFIGURATION, szBaseURL, &ulChars))
			{
				_AtlModule.m_bstrServerPort = szBaseURL;
				return bRetC;
			}

			rk.Close();
		}
	}

	return bRetC;
}

#ifdef _MANAGED
#pragma managed(pop)
#endif




// Used to determine whether the DLL can be unloaded by OLE
STDAPI DllCanUnloadNow(void)
{
    return _AtlModule.DllCanUnloadNow();
}


// Returns a class factory to create an object of the requested type
STDAPI DllGetClassObject(REFCLSID rclsid, REFIID riid, LPVOID* ppv)
{
    return _AtlModule.DllGetClassObject(rclsid, riid, ppv);
}


// DllRegisterServer - Adds entries to the system registry
STDAPI DllRegisterServer(void)
{
    // registers object, typelib and all interfaces in typelib
    HRESULT hr = _AtlModule.DllRegisterServer();
	return hr;
}


// DllUnregisterServer - Removes entries from the system registry
STDAPI DllUnregisterServer(void)
{
	HRESULT hr = _AtlModule.DllUnregisterServer();
	return hr;
}

